;
;	8253eXgvO (MZ-1500p)
;

_NL	EQU	0009h		;sȊOȂs DES:AF

CLKX	EQU	0
CLKY	EQU	1
OUTX	EQU	0
OUTY	EQU	3
MSETX	EQU	0
MSETY	EQU	10
R_L_X	EQU	2
R_L_Y	EQU	MSETY+1
MODEX	EQU	R_L_X
MODEY	EQU	R_L_Y+1
BCDX	EQU	R_L_X
BCDY	EQU	MODEY+1
CNTX	EQU	0
CNTY	EQU	BCDY+2
CSETX	EQU	2
CSETY	EQU	CNTY+1
RCNTX	EQU	2
RCNTY	EQU	CSETY+1
ITEMX	EQU	12
HELPY	EQU	20

MI_VRAMADDR	EQU	0
MI_STRLEN	EQU	2
MI_VALUE	EQU	3
MI_MAXVALUE	EQU	4
MI_COUNT	EQU	5
MI_PREVITEM	EQU	6
MI_NEXTITEM	EQU	8
MI_EXEC		EQU	10
MI_STRLIST	EQU	12

	ORG	1200h

check1500:
	LD	HL, 0001h
	LD	A, (HL)
	OR	A
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	CP	0E8h
	JR	Z, entry
@@:	CALL	_NL
	LD	DE, err1500
	RST	18h
	JP	00ADh
err1500:
	DB	"MZ-1500 ONLY!", 0Dh

entry:
	DI
	LD	A, 01_11_101_0B
	LD	(0E007h), A

	LD	HL, 0D000h
	LD	DE, 0D001h
	LD	BC, 999
	LD	(HL), 0
	LDIR

	LD	HL, 0D800h
	LD	DE, 0D801h
	LD	BC, 999
	LD	(HL), 70h
	LDIR

	LD	A, 71h
	LD	(0D800h + 40   + 37), A
	LD	(0D800h + 40*2 + 37), A
	LD	(0D800h + 40*3 + 37), A

	CALL	printmsgs
	LD	HL, 0D000h + CLKY * 40 + 6
	CALL	draw_wave_0
	LD	HL, 0D000h + OUTY * 40 + 6
	CALL	draw_wave_0

	CALL	proc_modeset
	CALL	proc_counter_set

	LD	IX, item_rl
	CALL	draw_all_menuitem
	LD	IX, item_rl
mainloop:
	CALL	WAIT_VBLNK
	CALL	keyin
	CP	' '
	JR	NZ, @f
	CALL	process_clock
	LD	HL, clock0
	CALL	get_dispcode
	LD	HL, 0D000h + CLKY * 40 + 6
	CALL	draw_wave
	LD	HL, out0
	CALL	get_dispcode
	LD	HL, 0D000h + OUTY * 40 + 6
	CALL	draw_wave
	JR	mainloop
@@:	CALL	proc_menu
	JR	mainloop

clock0:	DB	0
clock1:	DB	0
out0:	DB	0
out1:	DB	0

process_clock:
	LD	A, (clock1)
	LD	(clock0), A
	XOR	1
	LD	(clock1), A
	LD	C, 01_11_000_0B
	OR	A
	JR	Z, @f
	LD	C, 01_11_101_0B
@@:	LD	A, C
	LD	(0E007h), A		; Ch.1 [hZbgAOUTω

	LD	A, (out1)
	LD	(out0), A
	IN	A, (0FEh)
	AND	20h			; INT1 (OUT2)
	RLCA
	RLCA
	RLCA
	LD	(out1), A

	CALL	scroll_count
	LD	A, (item_rcnt + MI_VALUE)
	OR	A
	JR	Z, @f
	CALL	read_counter
	CALL	draw_count
@@:
	RET

get_dispcode:
	LD	A, (HL)
	ADD	A, A
	INC	HL
	ADD	A, (HL)
	ADD	A, dispc_table & 00FFh
	LD	L, A
	ADC	A, dispc_table >> 8
	SUB	L
	LD	H, A
	LD	A, (HL)
	RET
dispc_table:
	DB	3Ch, 72h, 32h, 70h

printmsgs:
	LD	HL, mes
@1:	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	INC	HL
	LD	A, D
	OR	E
	RET	Z
@2:	LD	A, (HL)
	INC	HL
	CP	0FFh
	JR	Z, @1b
	LD	(DE), A
	INC	DE
	JR	@2b

draw_wave:
	LD	D, H
	LD	E, L
	INC	HL
	LD	BC, 31
	LDIR
	LD	(DE), A
	RET

draw_wave_0:
	LD	B, 32
	LD	A, 3Ch
@@:	LD	(HL), A
	INC	HL
	DJNZ	@b
	RET

mes:
	DW	0D000h + CLKY * 40 + CLKX
	DISPC	"CLOCK", 0FFh
	DW	0D000h + OUTY * 40 + OUTX
	DISPC	"OUT", 0FFh
	DW	0D000h + MSETY * 40 + MSETX
	DISPC	"MODE SET", 0FFh
	DW	0D000h + R_L_Y * 40 + R_L_X
	DISPC	"READ/LOAD", 0FFh
	DW	0D000h + MODEY * 40 + MODEX
	DISPC	"MODE", 0FFh
	DW	0D000h + BCDY * 40 + BCDX
	DISPC	"BCD", 0FFh
	DW	0D000h + CNTY * 40 + CNTX
	DISPC	"COUNTER", 0FFh
	DW	0D000h + CSETY * 40 + CSETX
	DISPC	"SET", 0FFh
	DW	0D000h + RCNTY * 40 + RCNTX
	DISPC	"READ", 0FFh
	DW	0D000h + HELPY * 40
	DISPC	" [",50h,"][",80h,"]: SELECT AN ITEM", 0FFh
	DW	0D000h + (HELPY+1) * 40
	DISPC	" [",45h,"][",40h,"]: CHANGE VALUES", 0FFh
	DW	0D000h + (HELPY+2) * 40
	DISPC	"   [CR]: MODE SET OR WRITE COUNTER", 0FFh
	DW	0D000h + (HELPY+3) * 40
	DISPC	"[SPACE]: TRIGGER A CLOCK", 0FFh
	DW	0D000h + (HELPY+4) * 40
	DISPC	"[0-9],[A-F]: CHANGE COUNTER VALUE", 0FFh
	DW	0000h

WAIT_VBLNK:
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b
	RET

cur_rl:
	DB	0

read_counter:
	LD	A, (cur_rl)
	OR	A
	RET	Z
	DEC	A
	JR	NZ, @f
rcnt_l:	LD	A, 10_00_000_0B
	LD	(0E007h), A
	LD	A, (0E006h)
	LD	C, A
	LD	B, 0
	RET
@@:	DEC	A
	JR	NZ, rcnt_lh
rcnt_h:	LD	A, 10_00_000_0B
	LD	(0E007h), A
	LD	A, (0E006h)
	LD	C, 0
	LD	B, A
	RET
rcnt_lh:LD	A, 10_00_000_0B
	LD	(0E007h), A
	LD	A, (0E006h)
	LD	C, A
	LD	A, (0E006h)
	LD	B, A
	RET

last_count:
	DW	0

draw_count:
	LD	HL, (last_count)
	OR	A
	SBC	HL, BC
	RET	Z

	LD	(last_count), BC
	LD	HL, 0D000h + (OUTY+2) * 40 + 37
	LD	A, B
	RRA
	RRA
	RRA
	RRA
	CALL	hexa
	LD	DE, 40-1
	ADD	HL, DE
	LD	A, B
	CALL	hexa
	LD	DE, 40-1
	ADD	HL, DE
	LD	A, C
	RRA
	RRA
	RRA
	RRA
	CALL	hexa
	LD	DE, 40-1
	ADD	HL, DE
	LD	A, C
	CALL	hexa
	RET

scroll_count:
	PUSH	BC
	LD	B, 4
	LD	HL, 0D000h + (OUTY+2) * 40 + 6
@@:	PUSH	BC
	PUSH	HL
	LD	D, H
	LD	E, L
	INC	HL
	LD	BC, 31
	LDIR
	POP	HL
	XOR	A
	LD	(DE), A
	LD	DE, 40
	ADD	HL, DE
	POP	BC
	DJNZ	@b
	POP	BC
	RET

draw_all_menuitem:
	PUSH	IX
	POP	BC
@@:	LD	L, (IX+MI_NEXTITEM)
	LD	H, (IX+MI_NEXTITEM+1)
	PUSH	HL
	OR	A
	SBC	HL, BC
	JR	Z, @f
	POP	IX
	PUSH	BC
	CALL	draw_menuitem
	POP	BC
	JR	@b
@@:	POP	IX
	CALL	draw_menuitem
	LD	A, 72h
	CALL	draw_menuattr
	RET

proc_menu:
	LD	C, A
	LD	A, (IX+MI_MAXVALUE)
	OR	A
	JP	Z, proc_menu_counter
	LD	A, C
	CP	0Dh		; write
	JR	NZ, @f
proc_menu_exec:
	LD	L, (IX+MI_EXEC)
	LD	H, (IX+MI_EXEC+1)
	JP	(HL)
@@:	CP	1Ch		; right
	JR	NZ, @f
	INC	(IX+MI_VALUE)
	LD	A, (IX+MI_MAXVALUE)
	CP	(IX+MI_VALUE)
	JR	NC, draw_menuitem
	LD	(IX+MI_VALUE), 0
	JR	draw_menuitem
@@:	CP	1Dh		; left
	JR	NZ, @f
	DEC	(IX+MI_VALUE)
	JP	P, draw_menuitem
	LD	A, (IX+MI_MAXVALUE)
	LD	(IX+MI_VALUE), A
	JR	draw_menuitem
@@:	CP	1Fh		; down
	JR	NZ, @f
proc_menu_down:
	LD	E, (IX+MI_NEXTITEM)
	LD	D, (IX+MI_NEXTITEM+1)
	JR	@1f
@@:	CP	1Eh		; up
	RET	NZ
proc_menu_up:
	LD	E, (IX+MI_PREVITEM)
	LD	D, (IX+MI_PREVITEM+1)
@1:	LD	L, (IX+MI_VRAMADDR)
	LD	H, (IX+MI_VRAMADDR+1)
	SET	3, H
	LD	B, (IX+MI_STRLEN)
	LD	A, 70h
@@:	LD	(HL), A
	INC	HL
	DJNZ	@b
	PUSH	DE
	POP	IX
	LD	A, 72h
draw_menuattr:
	LD	L, (IX+MI_VRAMADDR)
	LD	H, (IX+MI_VRAMADDR+1)
	SET	3, H
	LD	B, (IX+MI_STRLEN)
@@:	LD	(HL), A
	INC	HL
	DJNZ	@b
	RET
draw_menuitem:
	LD	A, (IX+MI_VALUE)
	ADD	A, A
	ADD	A, MI_STRLIST
	ADD	A, IXL
	LD	L, A
	ADC	A, IXH
	SUB	L
	LD	H, A
	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	EX	DE, HL
	LD	E, (IX+MI_VRAMADDR)
	LD	D, (IX+MI_VRAMADDR+1)
	LD	C, (IX+MI_STRLEN)
	LD	B, 0
	LDIR
	RET

proc_modeset:
	LD	A, (item_rl+MI_VALUE)
	RLCA
	RLCA
	RLCA
	RLCA
	LD	C, A
	LD	A, (item_mode+MI_VALUE)
	RLCA
	OR	C
	LD	C, A
	LD	A, (item_bcd+MI_VALUE)
	OR	C
	OR	10_00_000_0B
	LD	(0E007h), A	; mode set
	LD	A, (item_rl+MI_VALUE)
	LD	(cur_rl), A
	RET

proc_menu_counter:
	LD	A, C
	CP	0Dh		; write
	JP	Z, proc_menu_exec
	CP	1Eh		; up
	JP	Z, proc_menu_up
	CP	1Fh		; down
	JP	Z, proc_menu_down
	CP	1Ch		; right
	JR	NZ, @f
	INC	(IX+MI_COUNT)
	JR	@9f
@@:	CP	1Dh		; left
	JR	NZ, @f
	DEC	(IX+MI_COUNT)
	JR	@9f
@@:	CP	'0'
	RET	C
	CP	'9'+1
	JR	NC, @f
	SUB	'0'
@1:	LD	C, (IX+MI_COUNT)
	SLA	C
	SLA	C
	SLA	C
	SLA	C
	OR	C
	LD	(IX+MI_COUNT), A
	JR	@9f
@@:	CP	'A'
	RET	C
	CP	'F'+1
	JR	NC, @f
	SUB	'A'-10
	JR	@1b
@@:	RET
@9:	LD	L, (IX+MI_STRLIST)
	LD	H, (IX+MI_STRLIST+1)
	LD	A, (IX+MI_COUNT)
	LD	C, A
	RRA
	RRA
	RRA
	RRA
	CALL	hexa
	LD	A, C
	CALL	hexa
	JP	draw_menuitem

hexa:	AND	0Fh
	ADD	A, hextable & 00FFh
	LD	E, A
	ADC	A, hextable >> 8
	SUB	E
	LD	D, A
	LD	A, (DE)
	LD	(HL), A
	INC	HL
	RET

hextable:
	DISPC	"0123456789ABCDEF"

proc_counter_set:
	LD	A, (item_counter+MI_COUNT)
	LD	(0E006h), A
proc_nop:
	RET

item_rl:
	DW	0D000h + R_L_Y * 40 + ITEMX
	DB	21	; str len
	DB	1	; current
	DB	3	; max
	DB	0
	DW	item_counter	; upper item
	DW	item_mode	; lower item
	DW	proc_modeset	; [CR]
	DW	rl00, rl01, rl10, rl11

rl00:	DISPC	" 00:COUNTER LATCH OP."
rl01:	DISPC	" 01:LOW BYTE ONLY    "
rl10:	DISPC	" 10:HIGH BYTE ONLY   "
rl11:	DISPC	" 11:LOW TO HIGH BYTE "

item_mode:
	DW	0D000h + MODEY * 40 + ITEMX
	DB	10	; str len
	DB	0	; current
	DB	5	; max
	DB	0
	DW	item_rl		; upper item
	DW	item_bcd	; lower item
	DW	proc_modeset	; [CR]
	DW	mod000, mod001, mod010, mod011, mod100, mod101

mod000:	DISPC	"000:MODE 0"
mod001:	DISPC	"001:MODE 1"
mod010:	DISPC	"010:MODE 2"
mod011:	DISPC	"011:MODE 3"
mod100:	DISPC	"100:MODE 4"
mod101:	DISPC	"101:MODE 5"

item_bcd:
	DW	0D000h + BCDY * 40 + ITEMX
	DB	10	; str len
	DB	0	; current
	DB	1	; max
	DB	0
	DW	item_mode	; upper item
	DW	item_counter	; lower item
	DW	proc_modeset	; [CR]
	DW	bcd0, bcd1

bcd0:	DISPC	"  0:BINARY"
bcd1:	DISPC	"  1:BCD   "

item_counter:
	DW	0D000h + CSETY * 40 + ITEMX
	DB	2	; str len
	DB	0	; current
	DB	0	; max
	DB	00h	; count
	DW	item_bcd	; upper item
	DW	item_rcnt	; lower item
	DW	proc_counter_set	; [CR]
	DW	cnt0

cnt0:	DISPC	"00"

item_rcnt:
	DW	0D000h + RCNTY * 40 + ITEMX
	DB	3	; str len
	DB	1	; current
	DB	1	; max
	DB	0
	DW	item_counter	; upper item
	DW	item_rl		; lower item
	DW	proc_nop	; [CR]
	DW	rcnt0, rcnt1

rcnt0:	DISPC	"OFF"
rcnt1:	DISPC	"ON "


keyin:
REPEAT_START	EQU	65
REPEAT_SPAN	EQU	5
	LD	HL, newkeymap
	LD	DE, lastkeymap
	LD	BC, 10
	LDIR
	LD	HL, newkeymap
	LD	B, 10
@@:	LD	A, 0F0h + 10
	SUB	B
	LD	(0E000h), A
	LD	A, (0E001h)
	LD	(HL), A
	INC	HL
	DJNZ	@b
	LD	HL, newkeymap
	LD	DE, lastkeymap
	LD	B, 10
@2:	LD	A, (DE)
	XOR	(HL)
	JR	Z, @f
	LD	C, A
	AND	(HL)
	JP	Z, @1f
@@:	INC	DE
	INC	HL
	DJNZ	@2b

	LD	HL, newkeymap
	LD	B, 10
@2:	LD	A, (HL)
	XOR	0FFh
	JR	Z, @f
	LD	C, A
	CALL	@2f
	LD	A, (lastpressed)
	CP	(HL)
	JR	NZ, @f
	LD	HL, repcount
	DEC	(HL)
	JR	NZ, @9f
	LD	(HL), REPEAT_SPAN
	LD	A, (lastpressed)
	RET
@@:	INC	HL
	DJNZ	@2b
	XOR	A
	LD	(lastpressed), A

@9:	XOR	A
	RET

@1:	CALL	@2f
	LD	A, REPEAT_START
	LD	(repcount), A
	LD	A, (HL)
	LD	(lastpressed), A
	RET

@2:	LD	A, C
	LD	C, 0FFh
@@:	INC	C
	RRA
	JR	NC, @b
	LD	A, 10
	SUB	B
	ADD	A, A
	ADD	A, A
	ADD	A, A
	ADD	A, C
	ADD	A, keytable & 00FFh
	LD	L, A
	ADC	A, keytable >> 8
	SUB	L
	LD	H, A
	RET

lastpressed:
	DB	0
repcount:
	DB	0
repsubcount:
	DB	0
lastkeymap:
	DB	0FFh, 0FFh, 0FFh, 0FFh
	DB	0FFh, 0FFh, 0FFh, 0FFh
	DB	0FFh, 0FFh
newkeymap:
	DB	0FFh, 0FFh, 0FFh, 0FFh
	DB	0FFh, 0FFh, 0FFh, 0FFh
	DB	0FFh, 0FFh
keytable:
	DB	0Dh, ':', ';', 0,   0,   '=', 0,   0
	DB	0,   0,   0,   ')', '(', '@', 'Z', 'Y'
	DB	'X', 'W', 'V', 'U', 'T', 'S', 'R', 'Q'
	DB	'P', 'O', 'N', 'M', 'L', 'K', 'J', 'I'
	DB	'H', 'G', 'F', 'E', 'D', 'C', 'B', 'A'
	DB	'8', '7', '6', '5', '4', '3', '2', '1'
	DB	'.', ',', '9', '0', ' ', '-', '+', '*'
	DB	'/', '?', 1Dh, 1Ch, 1Fh, 1Eh, 0,   0	; left, right, down, up
	DB	0,   0,   0,   0,   0,   0,   0,   0
	DB	0,   0,   0,   0,   0,   0,   0,   0

; 32h	|_
; 3Ch	__
; 70h	~~
; 72h	|~
;
	END
